// Webservice Management Performance Tester
// CLIENT
// Author: Oliver Bohle o.bohle@tu-bs.de
// Technische Universitt Braunschweig
#include "../headers/myns.nsmap"
#include "../headers/SOAPdevmgrStub.h"      
#include <string.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <getopt.h>


char option[100];
struct soap soap;

char * getInterfaceType(enum ns__addrType at){
  if (at==IP) return "IP";
  if (at==ETH) return "ETH";
  return "NIXOS";
}








// ------------------ IFLIST ------------------------------
int serve_Interface(struct nsif__interfaceDescription *ifdescr,int printResult){
  int fault; 
  int i,j;
  struct interfacelist ifl;  
  

   fault=soap_call_nsif__getInterfaceInformation(&soap,option,"",*ifdescr,&ifl);
  //printf("Errorcode: %d\n",fault);
  if (fault!=SOAP_OK) {
    //soap_print_fault(&soap, stderr);
    return 1;
  }
  else{
    if (printResult){
      if (ifl.__size>0){
	printf("INTERFACELIST:\n");
	for (i=0;i<ifl.__size;i++) {
	  
	  switch (ifl.__ptr[i].type){
	  case IF_OTHER:   printf("other    = ");break;
	  case IF_ETHERNET:printf("ETHERNET = ");break;
	  case IF_LOOPBACK:printf("LOOPBACK = ");break;
	  case IF_VIRTUAL: printf("VIRTUAL  = ");break;
	  default:printf("NEW TYPE  =");break;
	  }
	  
	  printf("%-10s: MTU %5d,",ifl.__ptr[i].name,ifl.__ptr[i].mtu);
	  if (ifl.__ptr[i].address!=NULL) {
	    printf(" inet address=%s ",ifl.__ptr[i].address->addr);
	  }
	  if (ifl.__ptr[i].broadcast!=NULL)  printf(", broadcast=%s ",ifl.__ptr[i].broadcast->addr);
	  if (ifl.__ptr[i].netmask!=NULL)  printf(", netmask=%s ",ifl.__ptr[i].netmask->addr);
	  if (ifl.__ptr[i].dst_address!=NULL)  printf(", pointtopoint=%s ",ifl.__ptr[i].dst_address->addr);
	  if (ifl.__ptr[i].link_address!=NULL)  printf(", hardware address=%s ",ifl.__ptr[i].link_address->addr);
	  
	  printf(",flags: ");
	  for (j=0;j<ifl.__ptr[i].__sizeflags;j++){
	    printf(" %s",ifl.__ptr[i].flag[j]);
	    
	  } 
	  if (ifl.__ptr[i].__sizealias>0) printf(",alias: ");
	  for (j=0;j<ifl.__ptr[i].__sizealias;j++){
	    printf(" %s,",ifl.__ptr[i].alias[j]->addr);
	    
	  } 
	  printf("\n");
	}
      }else{
	printf("No interface with name \"%s\" found\n",ifdescr->name);
      }
    }
  }
  return 0;
}




// ----------------------- IFSTAT ----------------------------
int serve_IFstat(char *iface,int printResult){
  int fault,i;
  struct ifstatlist ifstat;
 
  
  fault=soap_call_nsif__getInterfaceStats(&soap,option,"",iface,&ifstat);
  if (fault!=SOAP_OK) {
    //soap_print_fault(&soap, stderr);
    return 1;
  }
  else{
    if (printResult){
	if (ifstat.__size>0){
	  printf("INTERFACESTATS:\n");
	  printf("          ||                            Receive Stats                                   ||                     Transmit Stats\n");
	  printf("Name      || bytes    packets  errors   drop     fifo    frame     compressed multicast ||");
	  printf(" bytes    packets  errors   drop     fifo     colls    carrier  compressed \n");
	  printf("------------------------------------------------------------------------------------------");
	  printf("---------------------------------------------------------------------------\n");
	  for (i=0;i<ifstat.__size;i++) {
	    printf("%-10s||",ifstat.__ptr[i].ifname);
	    printf(" %-8d",ifstat.__ptr[i].rx_bytes);
	    printf(" %-8d",ifstat.__ptr[i].rx_packets);
	    printf(" %-8d",ifstat.__ptr[i].rx_errors);
	    printf(" %-8d",ifstat.__ptr[i].rx_drop);
	    printf(" %-8d",ifstat.__ptr[i].rx_fifo);
	    printf(" %-8d",ifstat.__ptr[i].rx_frame);
	    printf(" %-8d",ifstat.__ptr[i].rx_compressed);
	    printf("   %-8d  ||",ifstat.__ptr[i].rx_multicast);
	    printf(" %-8d",ifstat.__ptr[i].tx_bytes);
	    printf(" %-8d",ifstat.__ptr[i].tx_packets);
	    printf(" %-8d",ifstat.__ptr[i].tx_errors);
	    printf(" %-8d",ifstat.__ptr[i].tx_drop);
	    printf(" %-8d",ifstat.__ptr[i].tx_fifo);
	    printf(" %-8d",ifstat.__ptr[i].tx_colls);
	    printf(" %-8d",ifstat.__ptr[i].tx_carrier);
	    printf(" %-8d",ifstat.__ptr[i].tx_compressed);
	    printf("\n");
	  }
	}else{
	  printf("No interface with name \"%s\" found\n",iface);
	}
    }
  }
  return 0;
}



// ----------------------- ROUTE ----------------------------
int serve_Route(struct nsrt__routingInformation *rtInf, int printResult){
  int fault;
  int i,j;
  struct routelist rl;
    
  fault=soap_call_nsrt__getRoutingEntrys(&soap,option,"",*rtInf,&rl);
  //printf("Errorcode: %d\n",fault);
  if (fault!=SOAP_OK) {
    //soap_print_fault(&soap, stderr);
    return 1;
  }
  else{
    if (printResult){
      if (rl.__size>0){
	printf("DESTINATION     GATWAY          NETMASK           METRIC REFCNT USE INTERFACE FLAGS\n");
	for (i=0;i<rl.__size;i++) {
	  printf("%-15s",rl.__ptr[i].dst_addr->addr);
	  printf("\t%-15s",rl.__ptr[i].gw_addr->addr);
	  printf("\t%-15s",rl.__ptr[i].nm_addr->addr);
	  printf("   %-3d",rl.__ptr[i].metric);
	  printf("    %-3d",rl.__ptr[i].refcnt);
	  printf("    %-3d",rl.__ptr[i].use);
	  printf(" %-10s",rl.__ptr[i].iface);
	  printf("<");
	  for (j=0;j<rl.__ptr[i].__sizeflags;j++){
	    if (j!=0) printf(",");
	    printf("%s",rl.__ptr[i].flag[j]);
	  }
	  printf(">");	
	  printf("\n");
	}
      }else{
	printf("No interface with name \"%s\" in routing table found\n",rtInf->iface);
      }
    }
  }
  return 0;
}


void help(){
  printf("usage: SOAPmanager [-phrsia?] [SWITCH] \n\n");
  printf("-?, --help               this output\n");       
  printf("-p, --port NUMBER        listening portnumber of the agent [DEFAULT:10080]\n");
  printf("-h, --host HOSTNAME      listening hostname of the agent   [DEFAULT:localhost]\n");
  printf("-a, --average            number of loops to average the result\n");
}



int main(int argc,char *argv[]){
  int port=10080;
  char host[100]="localhost";
  int loopnumber=100;
  int averagenumber=1;
  int printResult=1;
  struct timeval tvstart,tvend,tvdiff;
  struct timezone tzstart,tzend;
  int i,j,count;
  int opt_idx;
  char c;
  char optstring[13]="p:h:n:a:q?"; 
  double avgtime;
  double res1,res2,res3;
  int err1,err2,err3;
  static struct option long_options[] =
             {
               {"port",     1, 0, 'p'},
               {"host",     1, 0, 'h'},
               {"help",     0, 0, '?'},
	       {"number",1,0, 'n'},
	       {"average",1,0, 'a'},
	       {"quiet",1,0, 'q'},

               {0, 0, 0, 0}
             };
  
  int stepnum=9;
  int step[]={1, 10, 100, 250, 500, 1000, 2500, 5000, 10000};
   
  struct nsrt__routingInformation rti;
  struct nsif__interfaceDescription ifd;

  memset(&rti,0,sizeof(struct nsrt__routingInformation));
  memset(&ifd,0,sizeof(struct nsif__interfaceDescription)); 
 
  soap_init(&soap); // initialize runtime environment

  while((c=getopt_long(argc,argv,optstring,long_options,&opt_idx))!=-1){
    switch (c) {
    case 'p': port=strtol(optarg,NULL,10);printf("PORT=%d \n",port);break;
    case 'h': strcpy(host,optarg);printf("HOST=%s \n",host);break;
    case 'n': loopnumber=strtol(optarg,NULL,10);break;
    case 'a': averagenumber=strtol(optarg,NULL,10);break;
    case 'q': printResult=0;break;
    case '?': help();exit(1);break;
    default: printf("UNKNOWN=%c",c);printf ("Option %s", long_options[opt_idx].name);
      break;
    }
  } 
  
  if (optind < argc)
    {
      printf ("Nichtoptionselemente von ARGV: ");
      while (optind < argc)
	printf ("%s ", argv[optind++]);
      printf ("\n");
    }
  



  /**   REMOTE METHOD INVOCATION START **/
  sprintf(option,"%s:%d",host,port);
  printf("Initialising Soap... \n");
  
  
  count=0;
  printf("Starting Test...\n");
     printf("Number of loops to average result=%d\n",averagenumber);
  while(count<stepnum){
    loopnumber=step[count];
    err1=0;err2=0;err3=0;
    
    avgtime=0;
    //printf("Starting interfaceDescription-Test\n");
    for(j=0;j<averagenumber;j++){
     
      gettimeofday(&tvstart,&tzstart);
      for(i=0;i<loopnumber;i++)  
	{
	  err1+=serve_Interface(&ifd,printResult);
	}
      gettimeofday(&tvend,&tzend);
      tvdiff.tv_sec=tvend.tv_sec-tvstart.tv_sec;
      tvdiff.tv_usec=tvend.tv_usec-tvstart.tv_usec; 
      if (tvdiff.tv_usec<0){
	tvdiff.tv_sec--;
	tvdiff.tv_usec=1000000+tvdiff.tv_usec;
      }
      avgtime+=tvdiff.tv_sec;
      avgtime+=(tvdiff.tv_usec*0.000001);
      if (j!=0) {
	avgtime=avgtime/2.0;;
      }
    
    }
    //printf("interfaceDescription needed an average time of %lf sec\n",avgtime);
    res1=avgtime;


    avgtime=0;
    //printf("Starting interfaceStats-Test\n");
    for(j=0;j<averagenumber;j++){
      
      gettimeofday(&tvstart,&tzstart);
      for(i=0;i<loopnumber;i++)  
	{
	  err2+=serve_IFstat("",printResult);
	}
      gettimeofday(&tvend,&tzend);
      tvdiff.tv_sec=tvend.tv_sec-tvstart.tv_sec;
      tvdiff.tv_usec=tvend.tv_usec-tvstart.tv_usec; 
      if (tvdiff.tv_usec<0){
	tvdiff.tv_sec--;
	tvdiff.tv_usec=1000000+tvdiff.tv_usec;
      }
      avgtime+=tvdiff.tv_sec;
      avgtime+=(tvdiff.tv_usec*0.000001);
      if (j!=0) {
	avgtime=avgtime/2.0;;
      }
    
    }
    //printf("interfaceStat needed an average time of %lf sec\n",avgtime);
    res2=avgtime;


    //printf("Starting routingInformation-Test\n");
    avgtime=0;
    
    for(j=0;j<averagenumber;j++){
      
      
      gettimeofday(&tvstart,&tzstart);
      for(i=0;i<loopnumber;i++)  
	{
	  err3+=serve_Route(&rti,printResult);	
	}
      gettimeofday(&tvend,&tzend);
      tvdiff.tv_sec=tvend.tv_sec-tvstart.tv_sec;
      tvdiff.tv_usec=tvend.tv_usec-tvstart.tv_usec; 
      if (tvdiff.tv_usec<0){
	tvdiff.tv_sec--;
	tvdiff.tv_usec=1000000+tvdiff.tv_usec;
      }
      avgtime+=tvdiff.tv_sec;
      avgtime+=(tvdiff.tv_usec*0.000001);
      if (j!=0) {
	avgtime=avgtime/2.0;;
      }
      
    }
    //printf("routingInformation needed an average time of %lf sec\n",avgtime);
    res3=avgtime;
    printf("n=%6d  IF-INF= %lf sec, %d err    IF-STAT= %lf sec, %d err    RT-INF=%lf sec, %d err\n",loopnumber,res1,err1,res2,err2,res3,err3);
    count++;
  }
  printf("TEST DONE\n");

  soap_done(&soap); // close master socket
  return 0;
}

