// Webservice Device-Management 
// AGENT, aux.c
// Author: Oliver Bohle o.bohle@tu-bs.de
// Technische Universitt Braunschweig
#include "agent.h"


void error(char *funk, char *err, int exitval){
  printf("INTERNAL ERROR IN FUNCTION:%s :: %s\nExiting\n",funk,err);
  exit(exitval);
}


void warning(char *funk, char *warn){
  printf("INTERNAL WARNING IN FUNCTION:%s :: %s\n",funk,warn);
}


void print_ns__address(struct ns__address *ad){
  if (ad->type==IP) printf("IP: %s",ad->addr);
  if (ad->type==ETH) printf("ETH: %s",ad->addr);
}


struct ns__address * cp_ns__addr(struct ns__address *to,struct ns__address *from){
  to=(struct ns__address *) malloc(sizeof(struct ns__address));

  if (from==NULL) {to=NULL;return NULL;}
  if (from->type==ADDR_TYPE_IP){    
    to->type=IP;
    to->addr=(char *) calloc(AGENT_IPLEN,sizeof(char));
    strncat(to->addr,from->addr ,AGENT_IPLEN);
    return to;
  }
  if (from->type==ADDR_TYPE_ETH){
    to->type=ETH;
    to->addr=(char *) calloc(AGENT_ETHLEN,sizeof(char));
    strncat(to->addr,from->addr ,AGENT_ETHLEN);
    return to;
  } 
  return to;
}


/* Frees the memory structure of a ns__address struct */
void freeAddrStruct(struct ns__address *addr){
  if (addr!=NULL){
    if (addr->addr!=NULL)
      free(addr->addr);
    free(addr);
  }
  addr=NULL;
}
